using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.Net.Sockets;
using System.Threading;


namespace ServerTest1
{
    
    class Program
    {
        static Socket serversocket;
        static Socket clientsock;
        static List<string> ClientIPList;


        static void listenclient()
        {

            Socket LocalSock = clientsock;

            
            Console.WriteLine("Client connected..\n");
            Console.WriteLine("Client at: " + LocalSock.RemoteEndPoint.ToString());
            
            string ClientIP = LocalSock.RemoteEndPoint.ToString();

           

            string CurrentCommand = "";

            try
            {


                while (LocalSock.Connected == true)
                {

                    byte[] recs = new byte[2000];
                    int rcount = LocalSock.Receive(recs, recs.Length, 0);

                    if (rcount != 0)
                    {

                        string clientmessage = System.Text.Encoding.ASCII.GetString(recs);
                        clientmessage = clientmessage.Substring(0, rcount);

                        Console.WriteLine(clientmessage);

                        CurrentCommand = clientmessage;

                        // Test current command string
                        if (CurrentCommand != "")
                        {

                            if (CurrentCommand == "QUIT")
                            {
                                Console.WriteLine("Closing client connection..\n");
                                LocalSock.Close();
                                LocalSock = null;

                                for (int i = 0; i < ClientIPList.Count; i++)
                                {
                                    if (ClientIPList[i] == ClientIP)
                                    {

                                        ClientIPList.Remove(ClientIP);

                                    }

                                }

                            }

                            if (CurrentCommand == "CLIENTRENDER")
                            {

                                ClientIPList.Add(ClientIP);

                                // show the whole list..
                                if (ClientIPList.Count > 0)
                                {

                                    Console.WriteLine("Client Renderers:");
                                    for (int j = 0; j < ClientIPList.Count; j++)
                                    {
                                        Console.WriteLine(ClientIPList[j]);

                                    }
                                }



                            }


                            if (CurrentCommand == "CLIENTLIST")
                            {
                                string ClientIPS = "";

                                for (int i = 0; i < ClientIPList.Count; i++)
                                {
                                    ClientIPS += ClientIPList[i] + ",";



                                }

                                
                                    // send whole list
                                    ClientIPS = "CLIENTLIST+" + ClientIPS;

                                    byte[] sender = System.Text.Encoding.ASCII.GetBytes(ClientIPS);

                                    LocalSock.Send(sender, sender.Length, SocketFlags.None);

                                   


                              

                            }



                        }
                        CurrentCommand = "";


                    }
                    else
                    {
                        Console.WriteLine("Remote connection was closed..");
                        LocalSock.Shutdown(SocketShutdown.Both);
                        LocalSock.Close();


                    }
                }
            }
            catch (System.Exception e)
            {

                Console.WriteLine(e.Message);

                if (LocalSock != null)
                {

                    LocalSock.Shutdown(SocketShutdown.Both);
                    LocalSock.Close();
                }

                for (int i = 0; i < ClientIPList.Count; i++)
                {
                    if (ClientIPList[i] == ClientIP)
                    {

                        ClientIPList.Remove(ClientIP);

                    }

                }

            }

        }


        static void Main(string[] args)
        {

            serversocket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

            ClientIPList = new List<string>();

            try
            {

                IPHostEntry IPHost = Dns.GetHostEntry(Dns.GetHostName());

                string[] aliases = IPHost.Aliases;
                IPAddress[] addr = IPHost.AddressList;

                IPEndPoint ipepServer = new IPEndPoint(addr[0], 8090);

                serversocket.Bind(ipepServer);

                serversocket.Listen(-1);

                Console.WriteLine("Indigo rendering tracker server started!");


                while (true)
                {
                    clientsock = serversocket.Accept();

                    clientsock.LingerState = new LingerOption(false, 0);

                    if (clientsock.Connected)
                    {

                        // launch a new thread to handle this client
                        Thread tc = new Thread(new ThreadStart(listenclient));
                        tc.Start();
                    }
                }
            }
            catch (Exception ez)
            {
                Console.WriteLine("Could not start Tracker. " + ez.Message);
            }


        }
    }
}
